"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isBinaryFile = exports.isBinaryDoc = void 0;
const vscode_uri_1 = require("vscode-uri");
const LanguageIds_1 = require("../LanguageIds");
const normalizeLanguageIds_1 = require("./normalizeLanguageIds");
function isBinaryDoc(document) {
    return isBinaryFile(vscode_uri_1.URI.parse(document.uri), document.languageId);
}
exports.isBinaryDoc = isBinaryDoc;
function isBinaryFile(filenameUri, languageId) {
    if (languageId) {
        const ids = (0, normalizeLanguageIds_1.normalizeLanguageIds)(languageId);
        if (ids.length)
            return (0, LanguageIds_1.isGenerated)(ids);
    }
    const filename = vscode_uri_1.Utils.basename(filenameUri);
    return (0, LanguageIds_1.isGeneratedFile)(filename);
}
exports.isBinaryFile = isBinaryFile;
//# sourceMappingURL=isBinaryDoc.js.map