"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memorizeLastCall = void 0;
const util_1 = require("./util");
function memorizeLastCall(fn) {
    let last;
    return (...p) => {
        if (last && (0, util_1.isArrayEqual)(last.args, p)) {
            return last.value;
        }
        const args = p;
        const value = fn(...args);
        last = { args, value };
        return value;
    };
}
exports.memorizeLastCall = memorizeLastCall;
//# sourceMappingURL=memorizeLastCall.js.map